////////////////////////////////////////////////////////////////////////////////////////////////////
//                                      SunShine.mq4                                      //
//                                                                                //
//                                     E mail: Kozaka@ukr.net                                     //
////////////////////////////////////////////////////////////////////////////////////////////////////
#property copyright "Kozak Andrey"                                                                //
#property link "Kozaka@ukr.net"                                                                   //
////////////////////////////////////////////////////////////////////////////////////////////////////

extern int    MA_period = 26;
extern int    RSI_period = 14;
extern int    StopLoss = 400;
extern int    TakeProfit = 50;
extern int    TrailingStop = 20;
extern string Filter = "   ";
extern bool   DM = FALSE;
extern int    DM_period = 14;


int init()
{

 Alert("      !");

 return;
}


int start()
{
double RSI=iRSI(Symbol(),0,RSI_period,PRICE_CLOSE,0);
double MA=iMA(Symbol(),0,MA_period,0,MODE_SMA,PRICE_CLOSE,0);
double St=iStochastic(Symbol(),0,5,3,3,MODE_SMA,0,MODE_MAIN,0);
int ticket;


if(OrdersTotal()<1)
{
 if(Symbol() == "EURUSD" && Period() < PERIOD_M30)
 {
 if(RSI>55 && Bid>MA && Close[1]<MA && St<12 && DM==FALSE)
  {
    ticket=OrderSend(Symbol(),OP_BUY,Lots(),Ask,3,Bid-StopLoss*Point,Ask+TakeProfit*Point);
    OrderSelect(ticket,SELECT_BY_TICKET);
  }
  
    if(RSI<45 && Ask<MA && Close[1]>MA && St>88 && DM==FALSE)
     {
      ticket=OrderSend(Symbol(),OP_SELL,Lots(),Bid,3,Ask+StopLoss*Point,Bid-TakeProfit*Point);
      OrderSelect(ticket,SELECT_BY_TICKET);
     }
     
     if(DM==TRUE)
      {
        DeMarker(DM_period, RSI_period, MA_period);
      }
  }
  else
   {
     Print(" SunShine      EURUSD   M15  !!!");
   }
}
OrdersTral(TrailingStop);
return;
}

double Lots()
{
double lot = AccountLeverage()*AccountBalance()*0.01/10000;
double Lot = NormalizeDouble(lot,1);
 if(Lot<0.1) Lot = 0.1;
 if(Lot>30) Lot=30;
return(Lot);
}



void OrdersTral(int tral)
{
 for(int r=0;r<OrdersTotal();r++)
 {
   OrderSelect(r,SELECT_BY_POS);
   
     if(OrderType()==OP_BUY)
     {
       if(OrderOpenPrice()+tral*Point<Bid)
        {
          OrderModify(OrderTicket(),OrderOpenPrice(),Bid-tral*Point,OrderTakeProfit(),0);
        }
     }
     
        if(OrderType()==OP_SELL)
          {
            if(OrderOpenPrice()-tral*Point>Ask)
            if(Ask+tral*Point<OrderStopLoss())
             {
              {
                OrderModify(OrderTicket(),OrderOpenPrice(),Ask+tral*Point,OrderTakeProfit(),0);
              }
             }
          }
 
 
 }


return;
}

void DeMarker(int dm_period, int rsi_period, int ma_period)
{
 double Demarker=iDeMarker(Symbol(),0,dm_period,0);
 double RSI=iRSI(Symbol(),0,rsi_period,PRICE_CLOSE,0);
 double MA=iMA(Symbol(),0,ma_period,0,MODE_SMA,PRICE_CLOSE,0);
 double St=iStochastic(Symbol(),0,5,3,3,MODE_SMA,0,MODE_MAIN,0);
 int ticket; 
   if(RSI>55 && Bid>MA && Close[1]<MA && St<12 && DM<0.2)
  {
    ticket=OrderSend(Symbol(),OP_BUY,Lots(),Ask,3,Bid-StopLoss*Point,Ask+TakeProfit*Point);
    OrderSelect(ticket,SELECT_BY_TICKET);
  }
  
    if(RSI<45 && Ask<MA && Close[1]>MA && St>88 && DM>0.8)
     {
      ticket=OrderSend(Symbol(),OP_SELL,Lots(),Bid,3,Ask+StopLoss*Point,Bid-TakeProfit*Point);
      OrderSelect(ticket,SELECT_BY_TICKET);
     }

 return;
}


